/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_ex10.c,v 1.2 1997/09/25 18:13:17 ae59 Exp $ */
/*
$Log: t_ex10.c,v $
 * Revision 1.2  1997/09/25  18:13:17  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:21  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_ex10.c                              */
/*                                                              */
/*      Entries         : a_real t_ex10(arg)                    */
/*                        a_real arg;                           */
/*                                                              */
/*      Arguments       : arg  = argument of exponential        */
/*                                                              */
/*      Description     : 10**x                                 */
/*                                                              */
/*      Date            : 1992-07-22                            */
/*      1992-07-22 : add sun4_cpp_c =b=                         */
/*      1992-07-03 : remove {} from ln 10 definition     =b=    */
/*      1992-05-11 : changed "10" to "sizeof(ExtReal)"   CB     */
/*      1992-01-21 : new routine                                */
/****************************************************************/
 
#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif
 
#define ln10                  /* ln(10) */ \
           EXTREAL(0x40, 0x00,              \
                   0x93, 0x5D, 0x8D, 0xDD,  \
                   0xAA, 0xA8, 0xAC, 0x16)  
 /* --- Ende ln(10) Konstante --- */
/* log(10) = 2.30258509299404568401799145468436420759...     */
/* ->DD 8D 5D 93   16 AC A8 AA   2B D6 56 EA INTEL Darst.!!! */
 
/*--------------------------------------------------------------*
 | exp10(x) = 10**x  = exp(x*ln(10))      Punktroutine           |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int t_10ex(const ExtReal *arg, ExtReal *res)
#else
int t_10ex(arg, res)
const ExtReal   *arg;
      ExtReal   *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int t_10ex(ExtReal *arg, ExtReal *res)
#else
int t_10ex(arg, res)
ExtReal   *arg;
ExtReal   *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   int         rnd;        /* RundungsMode                       */
   int         ret;        /* Rueckgabe                          */
   int         check;      /* Rueckgabe von Makro ArgCheck       */
#ifdef ANSI_C
#if SUN4_CPP_C
static ExtReal logcnst;
static char    logvalue[sizeof(ExtReal)] = ln10;

memcpy(&logcnst,logvalue,sizeof(logcnst));
#else
static const ExtReal logcnst = ln10;
#endif
#else
static ExtReal logcnst;
static char    logvalue[sizeof(ExtReal)] = ln10;
 
memcpy(&logcnst,logvalue,sizeof(logcnst));
#endif
   /* --- pruefe Argument --- */
   ArgCheck1(Exp, arg, res);
 
   /* --- RundungsMode sichern, NEAR setzen --- */
   rnd  = getrndmode();
   setrndmode(NEAR);
 
   /* --- exp10() --- */
   mulee(arg, &logcnst, arg);   /* x = x*ln(10) */
   ret = (expee(arg, res) != 0);
 
   /* --- RundungsMode zuruecksetzen --- */
   setrndmode(rnd);
 
   return ret;
} /* exp10() */


#ifdef LINT_ARGS
a_real t_ex10(a_real arg)
#else
a_real t_ex10(arg)
a_real arg;
#endif
        {
        int      rnd, rc;
        a_real   res;
        ExtReal  a, r;
 
        E_SPUSH("t_ex10")
 
        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&arg, &a);
 
        if ((rc = t_10ex(&a, &r))!=0
            || (rc = extreal_to_longreal(&r, (LongReal *)&res))!=0)
           ieee_abortr1(rc, &arg);
 
        setrndmode(rnd);
 
        E_SPOPP("t_ex10")
        return res;
        }
/* ------------------------------------------------------------ */
